<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<title>polylib: testehrhart.c File Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<body>
<!-- Generated by Doxygen 1.6.1 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="main.html"><span>Main&nbsp;Page</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
    </ul>
  </div>
  <div class="tabs">
    <ul>
      <li><a href="files.html"><span>File&nbsp;List</span></a></li>
      <li><a href="globals.html"><span>File&nbsp;Members</span></a></li>
    </ul>
  </div>
</div>
<div class="contents">
<h1>testehrhart.c File Reference</h1><code>#include &lt;stdio.h&gt;</code><br/>
<code>#include &lt;stdlib.h&gt;</code><br/>
<code>#include &lt;ctype.h&gt;</code><br/>
<code>#include &lt;string.h&gt;</code><br/>
<code>#include &lt;unistd.h&gt;</code><br/>
<code>#include &lt;<a class="el" href="assert_8h_source.html">assert.h</a>&gt;</code><br/>
<code>#include &lt;<a class="el" href="polylib_8h_source.html">polylib/polylib.h</a>&gt;</code><br/>
<code>#include &lt;<a class="el" href="homogenization_8h_source.html">polylib/homogenization.h</a>&gt;</code><br/>
<code>#include &quot;config.h&quot;</code><br/>

<p><a href="testehrhart_8c_source.html">Go to the source code of this file.</a></p>
<table border="0" cellpadding="0" cellspacing="0">
<tr><td colspan="2"><h2>Defines</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">#define&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="testehrhart_8c.html#a995bc50ed450a1f0b16b6a26a845991f">EP_EVALUATION</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">#define&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="testehrhart_8c.html#a1e2dfa3e09e21872dcebe9928e1c6f83">getopt_long</a>(a, b, c, d, e)&nbsp;&nbsp;&nbsp;getopt(a,b,c)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">#define&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="testehrhart_8c.html#a59799636dce6e7dfa2ce20c48147fa6b">WS</a>&nbsp;&nbsp;&nbsp;0</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">#define&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="testehrhart_8c.html#ade591ac8b3c36da1f2115f2dcaa1f75c">EPRINT_ALL_VALIDITY_CONSTRAINTS</a></td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">define this to print all constraints on the validity domains if not defined, only new constraints (not in validity domain given by the user) are printed  <a href="#ade591ac8b3c36da1f2115f2dcaa1f75c"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">#define&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="testehrhart_8c.html#ab33c076ab65d4d23c5a4f6a496b0aefb">REDUCE_DEGREE</a></td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">The following are mainly for debug purposes.  <a href="#ab33c076ab65d4d23c5a4f6a496b0aefb"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">#define&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="testehrhart_8c.html#ab82d76b3dd0632715d69af9117f9c6ed">ALL_OVERFLOW_WARNINGS</a></td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">define this to print one warning message per domain overflow these overflows should no longer happen since version 4.20  <a href="#ab82d76b3dd0632715d69af9117f9c6ed"></a><br/></td></tr>
<tr><td colspan="2"><h2>Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="testehrhart_8c.html#a3c04138a5bfe5d72780bb7e82a18e627">main</a> (int argc, char **argv)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">EPRINT : print results while computing the ehrhart polynomial.  <a href="#a3c04138a5bfe5d72780bb7e82a18e627"></a><br/></td></tr>
</table>
<hr/><h2>Define Documentation</h2>
<a class="anchor" id="ab82d76b3dd0632715d69af9117f9c6ed"></a><!-- doxytag: member="testehrhart.c::ALL_OVERFLOW_WARNINGS" ref="ab82d76b3dd0632715d69af9117f9c6ed" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define ALL_OVERFLOW_WARNINGS</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>define this to print one warning message per domain overflow these overflows should no longer happen since version 4.20 </p>

<p>Definition at line <a class="el" href="testehrhart_8c_source.html#l00110">110</a> of file <a class="el" href="testehrhart_8c_source.html">testehrhart.c</a>.</p>

</div>
</div>
<a class="anchor" id="a995bc50ed450a1f0b16b6a26a845991f"></a><!-- doxytag: member="testehrhart.c::EP_EVALUATION" ref="a995bc50ed450a1f0b16b6a26a845991f" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define EP_EVALUATION</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="testehrhart_8c_source.html#l00038">38</a> of file <a class="el" href="testehrhart_8c_source.html">testehrhart.c</a>.</p>

</div>
</div>
<a class="anchor" id="ade591ac8b3c36da1f2115f2dcaa1f75c"></a><!-- doxytag: member="testehrhart.c::EPRINT_ALL_VALIDITY_CONSTRAINTS" ref="ade591ac8b3c36da1f2115f2dcaa1f75c" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define EPRINT_ALL_VALIDITY_CONSTRAINTS</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>define this to print all constraints on the validity domains if not defined, only new constraints (not in validity domain given by the user) are printed </p>

<p>Definition at line <a class="el" href="testehrhart_8c_source.html#l00059">59</a> of file <a class="el" href="testehrhart_8c_source.html">testehrhart.c</a>.</p>

</div>
</div>
<a class="anchor" id="a1e2dfa3e09e21872dcebe9928e1c6f83"></a><!-- doxytag: member="testehrhart.c::getopt_long" ref="a1e2dfa3e09e21872dcebe9928e1c6f83" args="(a, b, c, d, e)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define getopt_long</td>
          <td>(</td>
          <td class="paramtype">a, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">b, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">c, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">d, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">e&nbsp;</td>
          <td class="paramname"></td>
          <td>&nbsp;)&nbsp;</td>
          <td>&nbsp;&nbsp;&nbsp;getopt(a,b,c)</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="testehrhart_8c_source.html#l00041">41</a> of file <a class="el" href="testehrhart_8c_source.html">testehrhart.c</a>.</p>

<p>Referenced by <a class="el" href="testehrhart_8c_source.html#l00130">main()</a>.</p>

</div>
</div>
<a class="anchor" id="ab33c076ab65d4d23c5a4f6a496b0aefb"></a><!-- doxytag: member="testehrhart.c::REDUCE_DEGREE" ref="ab33c076ab65d4d23c5a4f6a496b0aefb" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define REDUCE_DEGREE</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>The following are mainly for debug purposes. </p>
<p>You shouldn't need to change anything for daily usage... you may define each macro independently </p>
<ol>
<li>
define EDEBUG minimal debug </li>
<li>
define EDEBUG1 prints enumeration points </li>
<li>
define EDEBUG11 prints number of points </li>
<li>
define EDEBUG2 prints domains </li>
<li>
define EDEBUG21 prints more domains </li>
<li>
define EDEBUG3 prints systems of equations that are solved </li>
<li>
define EDEBUG4 prints message for degree reduction </li>
<li>
define EDEBUG5 prints result before simplification </li>
<li>
define EDEBUG6 prints domains in Preprocess </li>
<li>
define EDEBUG61 prints even more in Preprocess </li>
<li>
define EDEBUG62 prints domains in Preprocess2 </li>
</ol>
<p>Reduce the degree of resulting polynomials </p>

<p>Definition at line <a class="el" href="testehrhart_8c_source.html#l00102">102</a> of file <a class="el" href="testehrhart_8c_source.html">testehrhart.c</a>.</p>

</div>
</div>
<a class="anchor" id="a59799636dce6e7dfa2ce20c48147fa6b"></a><!-- doxytag: member="testehrhart.c::WS" ref="a59799636dce6e7dfa2ce20c48147fa6b" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define WS&nbsp;&nbsp;&nbsp;0</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="testehrhart_8c_source.html#l00050">50</a> of file <a class="el" href="testehrhart_8c_source.html">testehrhart.c</a>.</p>

</div>
</div>
<hr/><h2>Function Documentation</h2>
<a class="anchor" id="a3c04138a5bfe5d72780bb7e82a18e627"></a><!-- doxytag: member="testehrhart.c::main" ref="a3c04138a5bfe5d72780bb7e82a18e627" args="(int argc, char **argv)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int main </td>
          <td>(</td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>argc</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">char **&nbsp;</td>
          <td class="paramname"> <em>argv</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>EPRINT : print results while computing the ehrhart polynomial. </p>
<p>this is done by default if you build the executable ehrhart. (If EMAIN is defined). Don't define EMAIN here, it is defined when necessary in the makefile.</p>
<p>Notice: you may however define EPRINT without defining EMAIN, but in this case, you have to initialize the global variable param_name by calling Read_ParamNames before any call to ehrhart. This is NOT recommanded, unless you know what you do. EPRINT causes more debug messages to be printed. </p>

<p>Definition at line <a class="el" href="testehrhart_8c_source.html#l00130">130</a> of file <a class="el" href="testehrhart_8c_source.html">testehrhart.c</a>.</p>

<p>References <a class="el" href="Matop_8c_source.html#l00286">AddANullColumn()</a>, <a class="el" href="eval__ehrhart_8c_source.html#l00158">compute_poly()</a>, <a class="el" href="polyhedron_8c_source.html#l01906">Constraints2Polyhedron()</a>, <a class="el" href="homogenization_8c_source.html#l00172">dehomogenize_enumeration()</a>, <a class="el" href="types_8h_source.html#l00110">polyhedron::Dimension</a>, <a class="el" href="ehrhart_8c_source.html#l02220">Enumeration_Free()</a>, <a class="el" href="types_8h_source.html#l00207">_enumeration::EP</a>, <a class="el" href="types_8h_source.html#l00248">FOREVER</a>, <a class="el" href="param_8c_source.html#l00081">Free_ParamNames()</a>, <a class="el" href="testehrhart_8c_source.html#l00041">getopt_long</a>, <a class="el" href="matrix_8c_source.html#l00092">Matrix_Free()</a>, <a class="el" href="matrix_8c_source.html#l00203">Matrix_Read()</a>, <a class="el" href="types_8h_source.html#l00092">matrix::NbColumns</a>, <a class="el" href="types_8h_source.html#l00208">_enumeration::next</a>, <a class="el" href="vector_8c_source.html#l00760">p</a>, <a class="el" href="ehrhart_8c_source.html#l01860">Polyhedron_Enumerate()</a>, <a class="el" href="polyhedron_8c_source.html#l01603">Polyhedron_Free()</a>, <a class="el" href="polyparam_8c_source.html#l01693">Print_Domain()</a>, <a class="el" href="ehrhart_8c_source.html#l00192">print_evalue()</a>, <a class="el" href="param_8c_source.html#l00031">Read_ParamNames()</a>, <a class="el" href="types_8h_source.html#l00206">_enumeration::ValidityDomain</a>, <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00458">value_init</a>, <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00464">value_print</a>, <a class="el" href="source_2arith_2arithmetique_8h_source.html#l00463">value_read</a>, and <a class="el" href="ext__ehrhart_8c_source.html#l00020">WS</a>.</p>

</div>
</div>
</div>
<hr size="1"/><address style="text-align: right;"><small>Generated on Wed Nov 25 17:45:27 2009 for polylib by&nbsp;
<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.6.1 </small></address>
</body>
</html>
